Package com.io7m.waxmill.database.api

# Class WXMDatabaseConfiguration.Builder

java.lang.Object
com.io7m.waxmill.database.api.WXMDatabaseConfiguration.Builder

Enclosing class:
  WXMDatabaseConfiguration

    public static final class WXMDatabaseConfiguration.Builder
    extends java.lang.Object

Builds instances of type `WXMDatabaseConfiguration`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXMDatabaseConfiguration` | `build()` | Builds a new `WXMDatabaseConfiguration`.
  `WXMDatabaseConfiguration.Builder` | `from​(WXMDatabaseConfigurationType instance)` | Fill a builder with attribute values from the provided `WXMDatabaseConfigurationType` instance.
  `WXMDatabaseConfiguration.Builder` | `setDatabaseDirectory​(java.nio.file.Path databaseDirectory)` | Initializes the value for the `databaseDirectory` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final WXMDatabaseConfiguration.Builder from​(WXMDatabaseConfigurationType instance)
    Fill a builder with attribute values from the provided `WXMDatabaseConfigurationType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setDatabaseDirectory

    public final WXMDatabaseConfiguration.Builder setDatabaseDirectory​(java.nio.file.Path databaseDirectory)
    Initializes the value for the `databaseDirectory` attribute.
    Parameters:
      `databaseDirectory` - The value for databaseDirectory
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public WXMDatabaseConfiguration build()
    Builds a new `WXMDatabaseConfiguration`.
    Returns:
      An immutable instance of WXMDatabaseConfiguration
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing